/*!
* @file Item.h
* @brief ゲーム中のアイテムと付随要素のプロトタイプ
* @date 2013/12/11
* @author Deskull
* 2013 Sikabane Works.
*/

#pragma once

#include "stdafx.h"
#include "Deeangband.h"

#include "Dice.h"
#include "Effect.h"
#include "GameElement.h"
#include "ItemTemplate.h"
#include "SavingTable.h"

BOOST_CLASS_VERSION(Item, 1);

namespace Deeangband
{

	/*!
	* @class Item
	* @brief アイテムのクラス
	*/
	class Item : public ItemTemplate
	{
	private:

		Dice baseDamage; //!< ベースダメージのダイス
		WEIGHT weight; //!< アイテムの重量
		SavingTable baseSaving; //!< 基本セービング修正
		SavingTable plusSaving; //!< 追加セービング修正

		friend class boost::serialization::access;

		/*!
		* @brief クラスのシリアライズ化を設定する
		* @param archive アーカイブ化するクラスのアドレス
		* @param version データバージョン
		* @return XMLSerializeテンプレート
		*/
		template<class Archive> void serialize(Archive &archive, const unsigned int version) 
		{
			if(version >= 0)
			{
				archive & BOOST_SERIALIZATION_NVP(baseDamage);
				archive & BOOST_SERIALIZATION_NVP(weight);
				archive & BOOST_SERIALIZATION_NVP(baseSaving);
				archive & BOOST_SERIALIZATION_NVP(plusSaving);
			}
		}

	public:

		/*! 
		* @brief Itemクラスコンストラクタ(GameElementメンバ対応)
		* @param id GameElementのID
		* @param tag GameElementのタグ
		* @param gameWorld 所属元gameWorld参照ポインタ
		*/
		Item::Item(ID id, TAG tag, GameWorld *gameWorld);

		/*! 
		* @brief Itemクラスコンストラクタ
		*/
		Item::Item(void);

		/*! 
		* @brief Itemクラスデストラクタ
		*/
		Item::~Item(void);

		/*! 
		* @brief ダミーデータによる初期化
		* @return なし
		*/
		void Item::SetDammyData(void);

		/*! 受けた効果を処理する */
		bool Item::TakeEffect(Effect *effectPtr, POWER amount);


		/*!
		* @brief XMLシリアライズによるゲームデータ保存処理
		* @return なし
		*/
		void Item::XMLSave(std::string filename);

	};

}